%=============================================================================
%
% Simulate spatially correlated speckle noise 
% 
%
% Author: Aleksandra Pizurica, TELIN/RUG, Feb. 2001.
%=============================================================================

clear all;
close all;


% Read reference, noise-free image
    InputType=0;
    while (InputType~=1 & InputType~=2 & InputType~=3 & InputType~=4)  
     InputType=input('\nReference image format:\n1. "*.tif"\n2. "*.sg2"\n3. "*.mat"\n4. "*.bin"\n>>  ');
    end
    
 
imload;
Xclean=SCAN;
clear SCAN;
[M,N]=size(Xclean);
image_name=filename(1:(length(filename)-4));  

sigma=input('Noise standard deviation: ');
G=randn(M,N)*sigma + sqrt(-1)*randn(M,N)*sigma;
GL = nlfilter(G,[3 3],'mean(mean(x))');
GL=abs(GL);
m=mean(mean(GL));
GL=GL-m+1;
X=GL.*Xclean;

figure
subplot(2,1,1),imagesc(Xclean);
subplot(2,1,2),imagesc(X);

Filename=strcat(image_name,'_sig_',num2str(sigma),'.mat');
save(Filename,'X');